--- procps-2.0.7/watch.c.wide_watch	Mon Jul  1 12:10:07 2002
+++ procps-2.0.7/watch.c	Mon Jul  1 12:59:21 2002
@@ -194,6 +194,7 @@
       char *header;
       FILE *p;
       int x, y;
+      int last_was_eol; 
 
       if (screen_size_changed)
 	{
@@ -221,6 +222,7 @@
 	  do_exit(2);
 	}
 
+      last_was_eol = 0;
       for (y=2; y<height; y++)
 	{
 	  int eolseen = 0, tabpending = 0;
@@ -233,10 +235,23 @@
 		{
 		  /* if there is a tab pending, just spit spaces until the
 		     next stop instead of reading characters */
+		restart:
 		  if (!tabpending)
 		    do
 		      c = getc(p);
 		    while (c != EOF && !isprint(c) && c != '\n' && c != '\t');
+
+		  /* Avoid putting the newline first at the row if the last
+		   * character on the last row was not a newline.
+		   * This avoids empty lines when a newline gets pushed one char
+		   * off the end of a row.
+		   */
+		  if (x == 0 && c == '\n' && !last_was_eol)
+		    {
+		      last_was_eol = 1;
+		      goto restart;
+		    }
+		      
 		  if (c == '\n')
 		    eolseen = 1;
 		  else if (c == '\t')
@@ -261,6 +276,7 @@
 	      addch(c);
 	      if (attr)
 		standend();
+	      last_was_eol = eolseen;
 	    }
 	}
 
